'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));
var PropTypes = _interopDefault(require('prop-types'));
var styled = _interopDefault(require('styled-components'));

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __makeTemplateObject(cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
}

var Label = styled.label(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  cursor: pointer;\n  position: relative;\n  height: 1em;\n  display: flex;\n  align-items: center;\n"], ["\n  cursor: pointer;\n  position: relative;\n  height: 1em;\n  display: flex;\n  align-items: center;\n"])));
var CheckboxInput = styled.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  margin: 0 0.4em 0 0;\n  width: 14px;\n  height: 14px;\n  border-radius: 4px;\n  background-color: ", ";\n  box-shadow: rgb(153, 153, 153) 0px 0px 0px 1px inset;\n"], ["\n  margin: 0 0.4em 0 0;\n  width: 14px;\n  height: 14px;\n  border-radius: 4px;\n  background-color: ", ";\n  box-shadow: rgb(153, 153, 153) 0px 0px 0px 1px inset;\n"])), function (p) { return p.checked ? '#007bff' : '#fff'; });
var LabelText = styled.span(templateObject_3 || (templateObject_3 = __makeTemplateObject([""], [""])));
var Checkbox = function (_a) {
    var checked = _a.checked, onChange = _a.onChange, children = _a.children, props = __rest(_a, ["checked", "onChange", "children"]);
    var toggleChecked = function () {
        onChange(!checked);
    };
    return (React.createElement(Label, { onClick: toggleChecked, onKeyDown: function (e) {
            e.preventDefault();
            // toggle when focused and spacebar is hit
            if (e.keyCode === 32) {
                toggleChecked();
            }
        }, tabIndex: 0, role: "checkbox", "aria-checked": checked },
        React.createElement(CheckboxInput, { checked: checked }),
        React.createElement(LabelText, null, children)));
};
Checkbox.propTypes = {
    checked: PropTypes.bool.isRequired,
    onChange: PropTypes.func.isRequired,
    children: PropTypes.node,
};
Checkbox.defaultProps = {
    children: null,
};
var templateObject_1, templateObject_2, templateObject_3;
//# sourceMappingURL=index.js.map
